;  POPUP.LSP

(defun POPUP (string cflag / countr outrbox fil offset boxsize)
  (graphscr)
  (setq fil (open "CON" "w"))
  (setq countr 10)
  (esc "31m")
  (if (null cflag)
    (repeat 10 (esc (strcat (rtos countr 2 0) ";12f"))
      (princ "                                                 " fil)
      (setq countr (1+ countr))
    )
  )
  (esc "0m")
  (setq offset (rtos (- 37 (/ (strlen string ) 2.0)) 2 0))
  (esc (strcat "12;" offset "f"))
  (esc "1m")
  (esc (strcat "33m" string))
  (esc "16;36f")
  (esc "32mOK")
  (esc "17;15f")
  (esc "32mPick OK Box to Continue or any key to abort")
  (esc "0m")
  (close fil)
  (grtext)
  (setq outrbox (/ (getvar "viewsize") 1.82))
  (DRAWBOX (list (polar (getvar "viewctr")(/ pi 10) outrbox)
                 (polar (getvar "viewctr")(/ (* 9 pi) 10) outrbox)
                 (polar (getvar "viewctr")(/ (* 11 pi) 10) outrbox)
                 (polar (getvar "viewctr")(/ (* 19 pi) 10) outrbox)
           ) 2
  )
  (setq outrbox (/ (getvar "viewsize") 1.75))
  (DRAWBOX (list (polar (getvar "viewctr")(/ pi 10) outrbox)
                 (polar (getvar "viewctr")(/ (* 9 pi) 10) outrbox)
                 (polar (getvar "viewctr")(/ (* 11 pi) 10) outrbox)
                 (polar (getvar "viewctr")(/ (* 19 pi) 10) outrbox)
           ) 2
  )
  (GETOK)
)

(defun GETOK (/ input pt a b c d)
  (setq boxsize (/ (getvar "viewsize") 27))
  (setq a (polar (getvar "viewctr")(/ pi 4) boxsize))
  (setq b (polar (getvar "viewctr")(/ (* 3 pi) 4) boxsize))
  (setq c (polar (getvar "viewctr")(/ (* 5 pi) 4) boxsize))
  (setq d (polar (getvar "viewctr")(/ (* 7 pi) 4) boxsize))
  (DRAWBOX (list a b c d) 1)
  (setq input (grread))
  (setq pt (cadr input))
  (cond
    ((/= (car input) 3)(redraw))
    ((and (>= (car pt)(car b))
          (<= (car pt)(car a))
          (>= (cadr pt)(cadr d))
          (<= (cadr pt)(cadr a))
     )
     (if (= (getvar "CLAYER") G:layer) (redraw))
     (command "LAYER" "F" G:layer "")
    )
    (T (GETOK))
  )
  (princ)
)

(defun esc (arg)
  (cond
    ((null fil)(princ (strcat "\e[" arg))(princ))
    (T (princ (strcat "\e[" arg) fil))
  )
)

(defun drawbox (boxlist color / countr)
  (setq countr 0)
  (repeat 3
    (grdraw (nth countr boxlist)(nth (1+ countr) boxlist) color)
    (setq countr (1+ countr))
  )
  (grdraw (nth countr boxlist)(nth 0 boxlist) color)
)

(setvar "CMDECHO" 0)
(princ "\nLoaded")
(princ "\nUsage: FREZENTS followed by single pick")
(princ)

(defun c:FREZENTS (/ clear entity)
  (GETENT)
  (setq G:layer (cdr (assoc 8 (entget entity))))
  (POPUP (strcat "Entity is on layer " G:layer) clear)
)

(defun getent ()
  (setq entity (car (entsel "\nSelect an object: ")))
  (if (null entity)
    (progn
      (prin1 "\007")
      (princ "\nNo entity found!!")
      (princ)
      (GETENT)
    )
  )
  (redraw entity 3)
)
